<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8" />
  <title>HTML5 Summary &amp; Details: Browser Support</title>
  <meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=yes" />
  <link rel="stylesheet" type="text/css" media="screen" href="../../css/verdemoderna.css" title="default" />
  <link rel="stylesheet" type="text/css" media="screen" href="HTML5_SummaryDetailsTest.html.css" />
</head>
<body>
  <header id="header">
    <h1><span class="h1txt"><abbr>HTML</abbr>5 Summary &amp; Details: Browser Support</span></h1>
  </header>

  <main id="main">
    <p>This page contains various tests with the <code>details</code> and <code>summary</code>
      elements. The page was first created in March 2012 and updated in July 2015 and November 2021.
      See the test results in the <a href="#summary">summary</a> at the end of this page.
    </p>
    <p>For <abbr>HTML</abbr> pages that test specific combinations of
      <code>details</code>, <code>summary</code>, <code>tabindex</code> and <code>aria-describedby</code>,
      see the following list:
    </p>
    <ul>
      <li><a href="DetailsSummary_Plain.html">Plain example without <abbr>WAI</abbr>-<abbr>ARIA</abbr></a>.</li>
      <li><a href="DetailsSummary_Plain_Open.html">Plain example without <abbr>WAI</abbr>-<abbr>ARIA</abbr> (open)</a>.</li>
      <li><a href="DetailsSummary_tabindex.html">Using <code>tabindex</code></a>.</li>
      <li><a href="DetailsSummary_dl.html">Combining <code>details</code> with a definition list (<code>dl</code>)</a>.</li>
      <li><a href="DetailsSummary_dl_aria.html">Combining <code>details</code> with a definition list (<code>dl</code>) and <code>aria-describedby</code></a>.</li>
      <li><a href="DetailsSummary_ARIA.html">Using <code>tabindex</code> and <code>aria-describedby</code></a>.</li>
    </ul>

    <h2>With "open" attribute</h2>
    <details open="open">
      <summary>Show/Hide Details</summary>
      <p>How often have you had to write some JavaScript to create an interactive widget that shows and hides some content? 
        You might’ve even downloaded a whole JavaScript library to achieve such an effect. Well, it’s time to rejoice! 
        <abbr>HTML</abbr>5 provides a way to create this toggle feature with just a few lines of <abbr>HTML</abbr> and no JavaScript in sight 
        (depending on the browser, of course, but we’ll come to that later). And so we introduce to you the <code>&lt;details&gt;</code> element.
        <!-- http://html5doctor.com/the-details-and-summary-elements/ -->
      </p>
    </details>
  
    <h2>Without "open" attribute</h2>
    <details>
      <summary>Show/Hide Details</summary>
      <p>How often have you had to write some JavaScript to create an interactive widget that shows and hides some content? 
        You might’ve even downloaded a whole JavaScript library to achieve such an effect. Well, it’s time to rejoice! 
        <abbr>HTML</abbr>5 provides a way to create this toggle feature with just a few lines of <abbr>HTML</abbr> and no JavaScript in sight 
        (depending on the browser, of course, but we’ll come to that later). And so we introduce to you the <code>&lt;details&gt;</code> element.
      </p>
    </details>

    <h2>Without "open" attribute, and tabindex=0 on summary</h2>
    <p>Tabindex=0 makes the summary keyboard-focusable in Google Chrome 17 (2012), but not keyboard-actionable.
      In Google Chrome 95.0.4638.69 (November 2021) on Windows 10, the example below works perfectly fine with the keyboard.
    </p>
    <details>
      <summary tabindex="0">Show/Hide Details</summary>
      <p>How often have you had to write some JavaScript to create an interactive widget that shows and hides some content? 
        You might’ve even downloaded a whole JavaScript library to achieve such an effect. Well, it’s time to rejoice! 
        <abbr>HTML</abbr>5 provides a way to create this toggle feature with just a few lines of <abbr>HTML</abbr> and no JavaScript in sight 
        (depending on the browser, of course, but we’ll come to that later). And so we introduce to you the <code>&lt;details&gt;</code> element.
      </p>
    </details>

    <h2>Nested Details</h2>
    <details>
      <summary>Frequently Asked Questions</summary>
      <details>
        <summary>Where can I download Debian?</summary>
        <p>Go to the page <a href="https://www.debian.org/distrib/index.en.html">Getting Debian</a> and choose one of the options, such as downloading an installation image or a cloud image.</p>
      </details>
      <details>
        <summary>Where can I learn how to administer a Debian server?</summary>
        <p>Go to the <a href="https://wiki.debian.org/FrontPage">Debian wiki</a> or <a href="https://debian-handbook.info/">The Debian Administrator's Handbook</a>.
        </p>
      </details>
    </details>
    <h2 id="summary">Browser Support</h2>
    <h3>Tests 21 March 2012</h3>
    <ul>
      <li>Google Chrome 17.0.963.79m: supported for pointing devices but no keyboard access.</li>
      <li>Opera 11.61: not supported (<code>details</code> always open; no disclosure widget)</li>
      <li>Firefox 3.6.27: not supported (<code>details</code> always open; no disclosure widget)</li>
      <li>SeaMonkey 2.7.2: not supported (<code>details</code> always open; no disclosure widget)</li>
      <li>Internet Explorer 8.0.6001.18702: not supported (<code>details</code> always open; no disclosure widget)</li>
      <li>Safari 4.0.4 (Windows XP): not supported (<code>details</code> always open; no disclosure widget)</li>
    </ul>
    <h3>Tests 4 July 2015 (Microsoft Windows 7, 32 bits)</h3>
    <ul>
      <li>Google Chrome 43.0.2357.130 m: fully supported, both for pointing devices and keyboard access
        (tab to the <code>summary</code> element, then press the keyboard to open or close the details).
      </li>
      <li>Opera 30.0 (which uses WebKit as browser engine): 
        same support as in Google Chrome 43.
      </li>
      <li>Comodo Dragon 43.3.3.185 (a Chromium-based browser): 
        same support as in Google Chrome 43.
      </li>
      <li>Firefox 38.0.5: not supported (<code>details</code> always open; no disclosure widget)
        only the <code>summary</code> element with <code>tabindex=0</code> is keyboard-focusable.
      </li>
      <li>SeaMonkey 2.33.1: not supported (same as in Firefox)</li>
      <li>Internet Explorer 11.0.9600.17843: not supported (same as in Firefox)</li>
      <li>Opera 12.17 (last version based on Opera's own Presto engine):
        not supported (<code>details</code> always open; no disclosure widget;
        it is not clear which key on the keyboard would cycle through the <code>summary</code> elements
        except <kbd>d</kbd>, which cycles through at least all block-level elements on the page)
      </li>
    </ul>
    <h3>Tests 5 July 2015 (<abbr>GNU</abbr>/Linux Fedora 21 with GNOME, 64 bits)</h3>
    <ul>
      <li>Google Chrome 43.0.2357.130 (64-bit): fully supported (see results for Chrome on Windows 7, above).</li>
      <li>Firefox 33.1: 
          not supported (see results for Firefox on Windows 7, above).
      </li>
      <li>Web 3.14.2 (1:3.14.2-4.fc21, based on WebKit): 
        fully supported (same support as in Google Chrome).
      </li>
      <li>Midori 0.5.10 (0.5.10-1.fc21, based on WebKit): 
        fully supported (same support as in Google Chrome).
      </li>
      <li>Dillo (3.0.4.1-2.fc21):
        not supported (<code>details</code> always open; no disclosure widget;
        Dillo's support for <abbr>HTML</abbr>5 seems very incomplete).
      </li>
      <li>Arora 0.11.0-9.fc21 (based on the QtWebKit engine): 
        fully supported (same support as in Google Chrome).
      </li>
      <!--li>QupZilla 1.8.6-4.fc21 (based on WebKit core and Qt Framework):
        not tested (could not be launched after installation).
      </li-->
    </ul>
    <h3>Tests 9 November 2021 (Windows 10)</h3>
    <ul>
      <li>Google Chrome 95.0.4638.69: fully supported, both for pointing devices and keyboard access (tab to the <code>summary</code> element and press the <kbd>Return</kbd> key to toggle the details).</li>
      <li>Microsoft Edge 95.0.1020.44: fully supported; see Google Chrome, above.</li>
      <li>Brave 1.31.88 (Chromium 95.0.4638.69): fully supported; see Google Chrome, above.</li>
      <li>Mozilla Firefox 94.0.1: fully supported; see Google Chrome, above.</li>
      <li>SeaMonkey 2.53.9.1: fully supported; see Google Chrome, above.</li>
      <li>Internet Explorer 11: no support: all <code>details</code> are open by default; only the version with <code>tabindex=0</code> receives keyboard focus but none of the example can be toggled using the keyboard or the mouse.</li>
      <li>Otter Browser 1.0.0.2: mouse support only; none of the <code>details</code> receive keyboard focus, not even the element with <code>tabindex=0</code>.</li>
    </ul>
    <p>With <abbr>NVDA</abbr> 2019.3.1:</p>
    <ul>
      <li>Google Chrome 95.0.4638.69 with <abbr>NVDA</abbr>: fully supported. <abbr>NVDA</abbr> announces a button and adds wether is closed or expanded.</li>
      <li>Microsoft Edge 95.0.1020.44 with <abbr>NVDA</abbr>: fully supported; see Chrome and <abbr>NVDA</abbr>, above.</li>
      <li>Brave 1.31.88 with <abbr>NVDA</abbr>: fully supported; see Chrome and <abbr>NVDA</abbr>, above.</li>
      <li>Mozilla Firefox 94.0.1 with <abbr>NVDA</abbr>: fully supported; see Chrome and <abbr>NVDA</abbr>, above.</li>
      <!--@@SeaMonkey, Opera-->
      <li>Internet Explorer 11 with <abbr>NVDA</abbr>: all content of the page can be read by <abbr>NVDA</abbr>. The <code>summary</code> element with <code>tabindex=O</code> is announced as an input field.
        The other <code>summary</code> element are read like normal text.
      </li>
      <li>Otter Browser 1.0.0.2with <abbr>NVDA</abbr>: <abbr>NVDA</abbr> does not read any content on the page.</li>
    </ul>

    <h3>Tests 9 November 2021 (OpenSuse Leap 15.2 with <abbr>KDE</abbr>)</h3>
    <ul>
      <li>Mozilla Firefox 91.2.0esr: fully supported, both for pointing devices and keyboard access (tab to the <code>summary</code> element and press the <kbd>Return</kbd> key to toggle the details).</li>
      <li>SeaMonkey 2.53.8.1: fully supported, see Firefox, above.</li>
      <li>Chromium 95.0.4638.54 (openSUSE Build) stable: fully supported, see Firefox, above.</li>
      <li>Opera 80.0.4170.63: fully supported, see Firefox, above.</li>
      <li>Otter Browser 0.9.97 RC Y: mouse support only; none of the <code>details</code> receive keyboard focus, not even the element with <code>tabindex=0</code>.</li>
    </ul>

    <h2>Background Reading</h2>
    <ul>
      <li>
        <a href="https://a11ysupport.io/tech/html/summary_element">summary element (html)</a>, Accessibility Support, accessed on 09.11.2021.
      </li>
      <li>Can I use &hellip;: 
        <a href="http://caniuse.com/#feat=details">Support tables for Details &amp; Summary elements</a>.
      </li>
      <li>Tom Leadbetter: 
        <a href="http://html5doctor.com/the-details-and-summary-elements/">The details and summary elements</a>, 
        Tuesday, 9 August, 2011.
      </li>
      <li>Jason Kiss: 
        <a href="http://www.accessibleculture.org/articles/2012/03/screen-readers-and-details-summary/">Screen Readers and details/summary</a>,
        Accessible Culture, March 2012.
      </li>
      <li>Bugzilla0Mozilla: 
        <a href="https://bugzilla.mozilla.org/show_bug.cgi?id=591737">Bug 591737 - Support for <abbr>HTML</abbr>5's <code>&lt;details&gt;</code> and <code>&lt;summary&gt;</code></a>.
      </li>
      <li><span lang="nl">Mathias Bynens</span>:
        <a href="https://mathiasbynens.be/notes/html5-details-jquery">Bulletproof <abbr>HTML</abbr>5 <code>&lt;details&gt;</code> fallback using jQuery</a>,
        25 April 2010.
      </li>
      <li>Uche Ogbuji: 
        <a href="http://www.ibm.com/developerworks/library/x-think45/">Thinking <abbr title="Extensible Markup Language">XML</abbr>: The <abbr>XML</abbr> flavor of <abbr>HTML</abbr>5</a>,
        <abbr>XML</abbr>developerWorks, 8 July 2010.
      </li>
      <li>Bruce Lawson:
        <a href="http://html5doctor.com/html-5-xml-xhtml-5/"><abbr>HTML</abbr> 5 + <abbr>XML</abbr> = <abbr title="Extensible HyperText Markup Language">XHTML</abbr> 5</a> (2009).
      </li>
      <li>Chris Coyier:
        <a href="https://css-tricks.com/quick-reminder-that-details-summary-is-the-easiest-way-ever-to-make-an-accordion/">Quick Reminder that Details/Summary is the Easiest Way Ever to Make an Accordion</a>,
        <i class="website"><abbr>CSS</abbr>-Tricks</i>, 28.03.2018.
      </li>
      <li>Scott O'Hara:
        <a href="https://www.scottohara.me/blog/2018/09/03/details-and-summary.html">The details and summary elements</a>,
        <i class="blog"> scottohara.me</i>, 03.09.2018, updated on 03.10.2021.
        <br />According to this blog post, support is generally good, but on Mac <abbr>OS</abbr> VoiceOver does not announce the role, so blind users don't know the details can be expanded.
      </li>
      <li>
        <a href="https://github.com/WCAG-Audit-Discussions/NL-BE/issues/36">Summary/Details componenten</a>,
        <i class="website"><abbr>WCAG</abbr>-Audit-Discussions/NL-BE</i> (on GitHub).
      </li>
    </ul>

  </main>

  <footer id="footer">
    <p id="licence">
      <a class="image" rel="license" href="http://creativecommons.org/licenses/by-sa/4.0/">
      <img alt="Creative Commons License Attribution-ShareAlike" style="border-width:0" src="../../img/cc-licence-by-nc-sa-88x31.png" /><!--https://i.creativecommons.org/l/by-sa/4.0/88x31.png-->
      </a>
      <br />
      <a href="https://cstrobbe.gitlab.io/A11yWorks/">Accessibility Works</a> by
      <a href="https://gitlab.com/cstrobbe">Christophe Strobbe</a>
      is licensed under a <a lang="en-US" rel="license" href="http://creativecommons.org/licenses/by-sa/4.0/">Creative Commons Attribution-ShareAlike 4.0 International License</a>.
    </p>
    <p><a href="../../sitemap.html">Site map</a>.</p>
    <p>You can <a href="https://gitlab.com/cstrobbe/A11yWorks">fork the code</a> on GitLab.</p>
  </footer>
</body>
</html>
